Package org.eclipse.e4.ui.css.core.impl.engine

# Class AbstractCSSEngine

java.lang.Object
org.eclipse.e4.ui.css.core.impl.engine.AbstractCSSEngine

All Implemented Interfaces:
  `CSSEngine`

Direct Known Subclasses:
  `CSSEngineImpl`

public abstract class AbstractCSSEngine extends Object implements CSSEngine
Abstract CSS Engine manage style sheet parsing and store the `CSSStyleSheet` into `DocumentCSS`. To apply styles, call the `applyStyles(Object, boolean, boolean)` method. This method check if `ICSSPropertyHandler` is registered for apply the CSS property.

Version:
  1.0.0
Author:
  Angelo ZERR

## Field Summary

Fields
Modifier and Type
Field
Description
`protected boolean`
`computeDefaultStyle`
`protected List<ICSSPropertyHandlerProvider>`
`propertyHandlerProviders`
An ordered list of ICSSPropertyHandlerProvider

## Constructor Summary

Constructors
Constructor
Description
`AbstractCSSEngine()`
`AbstractCSSEngine(ExtendedDocumentCSS documentCSS)`

## Method Summary

Modifier and Type
Method
Description
`ICSSPropertyHandler`
`applyCSSProperty(Object element, String property, CSSValue value, String pseudo)`
Delegates the handle method.
`void`
`applyDefaultStyleDeclaration(Object element, boolean applyStylesToChildNodes)`
Apply initial style of the object node.
`void`
`applyDefaultStyleDeclaration(Object element, boolean applyStylesToChildNodes, CSSStyleDeclaration newStyle, String pseudoE)`
`void`
`applyInlineStyle(Object node, boolean applyStylesToChildNodes)`
Apply inline style of the object node.
`void`
`applyStyleDeclaration(Object element, CSSStyleDeclaration style, String pseudo)`
Apply style declaration to the object node.
`void`
`applyStyles(Object element, boolean applyStylesToChildNodes)`
Apply styles to the Object node (SWT Text,...).
`void`
`applyStyles(Object element, boolean applyStylesToChildNodes, boolean computeDefaultStyle)`
Apply styles to the Object node (SWT Text,...).
`String`
`convert(Object value, Object toType, Object context)`
Convert Object type of `toType` into CSSValue String.
`Object`
`convert(CSSValue value, Object toType, Object context)`
Convert CSSValue into Object type of `toType`.
`void`
`dispose()`
Call reset and dispose all resources
`String[]`
`getCSSCompositePropertiesNames(String property)`
Return array of CSS property name of the CSS `property`.
`CSSElementContext`
`getCSSElementContext(Object element)`
Get the `CSSElementContext` context of the object `node`.
`Collection<String>`
`getCSSProperties(Object element)`
Return the set of property names and handlers for the provided node.
`protected Collection<ICSSPropertyHandler>`
`getCSSPropertyHandlers(String property)`
`ICSSValueConverter`
`getCSSValueConverter(Object toType)`
Get CSSValue converter `ICSSValueConverter` which is enable to convert `toType` Object.
`CSSStyleDeclaration`
`getDefaultStyleDeclaration(Object element, String pseudoE)`
Get default `CSSStyleDeclaration` of the `node` for pseudo element `pseudoE` which can be null.
`CSSStyleDeclaration`
`getDefaultStyleDeclaration(Object widget, CSSStyleDeclaration newStyle, String pseudoE)`
`DocumentCSS`
`getDocumentCSS()`
Return the `DocumentCSS` used to store `CSSStyleSheet`.
`Element`
`getElement(Object element)`
Return the w3c Element linked to the Object element.
`IElementProvider`
`getElementProvider()`
Get `IElementProvider` registered used to retrieve w3c `Element` which wrap native widget.
`protected Map<Object,CSSElementContext>`
`getElementsContext()`
`CSSErrorHandler`
`getErrorHandler()`
Return `CSSErrorHandler` used to handles exception error.
`Object`
`getNativeWidget(Object element)`
`IResourcesLocatorManager`
`getResourcesLocatorManager()`
Get the `IResourcesLocatorManager` to use manage resources.
`IResourcesRegistry`
`getResourcesRegistry()`
Get the `IResourcesRegistry` registered used to cache/dispose resources.
`protected String[]`
`getStaticPseudoInstances(Element element)`
`ViewCSS`
`getViewCSS()`
Return the `ViewCSS` used to compute `CSSStyleDeclaration`.
`void`
`handleExceptions(Exception e)`
Handle exceptions thrown while parsing, applying styles.
`void`
`handleWidgetDisposed(Object widget)`
Called when a widget is disposed.
`protected void`
`hookNativeWidget(Object widget)`
Called when an element context is created for a native widget and registered with this engine.
`protected boolean`
`isVisible(Element elt)`
Allow the CSS engine to skip particular elements if they are not visible.
`abstract CSSParser`
`makeCSSParser()`
Return instance of CSS Parser.
`boolean`
`matches(org.w3c.css.sac.Selector selector, Object element, String pseudoElt)`
Check if the `selector` matches the object `node`.
`protected void`
`onStylesAppliedToChildNodes(Element element, NodeList nodes)`
Callback method called when styles applied of `nodes` children of the `element`.
`CSSStyleDeclaration`
`parseAndApplyStyleDeclaration(Object node, InputStream stream)`
Parse and apply style declaration from InputStream stream.
`CSSStyleDeclaration`
`parseAndApplyStyleDeclaration(Object node, Reader reader)`
Parse and apply style declaration from Reader reader.
`CSSStyleDeclaration`
`parseAndApplyStyleDeclaration(Object node, String style)`
Parse and apply style declaration from String style.
`CSSStyleDeclaration`
`parseAndApplyStyleDeclaration(Object node, org.w3c.css.sac.InputSource source)`
Parse and apply style declaration from InputSource source.
`CSSValue`
`parsePropertyValue(InputStream stream)`
Parse CSSValue from InputStream stream.
`CSSValue`
`parsePropertyValue(Reader reader)`
Parse CSSValue from Reader reader.
`CSSValue`
`parsePropertyValue(String value)`
Parse CSSValue from String value.
`CSSValue`
`parsePropertyValue(org.w3c.css.sac.InputSource source)`
Parse CSSValue from InputSource source.
`org.w3c.css.sac.SelectorList`
`parseSelectors(InputStream stream)`
Parse Selectors from InputStream.
`org.w3c.css.sac.SelectorList`
`parseSelectors(Reader reader)`
Parse Selectors from String value.
`org.w3c.css.sac.SelectorList`
`parseSelectors(String selector)`
Parse Selectors from String value.
`org.w3c.css.sac.SelectorList`
`parseSelectors(org.w3c.css.sac.InputSource source)`
Parse Selectors from InputSource value.
`CSSStyleDeclaration`
`parseStyleDeclaration(InputStream stream)`
Parse style declaration from InputStream stream.
`CSSStyleDeclaration`
`parseStyleDeclaration(Reader reader)`
Parse style declaration from Reader reader.
`CSSStyleDeclaration`
`parseStyleDeclaration(String style)`
Parse style declaration from String style.
`CSSStyleDeclaration`
`parseStyleDeclaration(org.w3c.css.sac.InputSource source)`
Parse style declaration from InputSource source.
`StyleSheet`
`parseStyleSheet(InputStream stream)`
Parse style sheet from InputStream stream.
`StyleSheet`
`parseStyleSheet(Reader reader)`
Parse style sheet from Reader reader.
`StyleSheet`
`parseStyleSheet(org.w3c.css.sac.InputSource source)`
Parse style sheet from InputSource source.
`void`
`registerCSSPropertyHandlerProvider(ICSSPropertyHandlerProvider handlerProvider)`
`void`
`registerCSSValueConverter(ICSSValueConverter converter)`
Register CSSValue converter `ICSSValueConverter`.
`void`
`reset()`
Reset all style sheet registered into CSS Engine.
`String`
`retrieveCSSProperty(Object element, String property, String pseudo)`
Retrieve String of `CSSValue` of the CSS `property` of the `node`.
`void`
`setElementProvider(IElementProvider elementProvider)`
Set `IElementProvider` registered used to retrieve w3c `Element` which wrap native widget.
`void`
`setErrorHandler(CSSErrorHandler errorHandler)`
Set the CSS Error Handler to manage exception.
`protected void`
`setResourceRegistryKeyFactory(ResourceRegistryKeyFactory keyFactory)`
`void`
`setResourcesLocatorManager(IResourcesLocatorManager resourcesLocatorManager)`
Set the `IResourcesLocatorManager` to use manage resources.
`void`
`setResourcesRegistry(IResourcesRegistry resourcesRegistry)`
Register `IResourcesRegistry` used to cache/dispose resources.
`void`
`unregisterCSSPropertyHandlerProvider(ICSSPropertyHandlerProvider handlerProvider)`
`void`
`unregisterCSSValueConverter(ICSSValueConverter converter)`
Unregister CSSValue converter `ICSSValueConverter`.

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Methods inherited from interface org.eclipse.e4.ui.css.core.engine.CSSEngine

`reapply`

## Field Details

### computeDefaultStyle

protected boolean computeDefaultStyle

### propertyHandlerProviders

protected List<ICSSPropertyHandlerProvider> propertyHandlerProviders
An ordered list of ICSSPropertyHandlerProvider

## Constructor Details

### AbstractCSSEngine

public AbstractCSSEngine()

### AbstractCSSEngine

public AbstractCSSEngine(ExtendedDocumentCSS documentCSS)

## Method Details

### parseStyleSheet

public StyleSheet parseStyleSheet(Reader reader) throws IOException
Description copied from interface: `CSSEngine`
Parse style sheet from Reader reader.

Specified by:
  `parseStyleSheet` in interface `CSSEngine`
Throws:
  `IOException`

### parseStyleSheet

public StyleSheet parseStyleSheet(InputStream stream) throws IOException
Description copied from interface: `CSSEngine`
Parse style sheet from InputStream stream.

Specified by:
  `parseStyleSheet` in interface `CSSEngine`
Throws:
  `IOException`

### parseStyleSheet

public StyleSheet parseStyleSheet(org.w3c.css.sac.InputSource source) throws IOException
Description copied from interface: `CSSEngine`
Parse style sheet from InputSource source.

Specified by:
  `parseStyleSheet` in interface `CSSEngine`
Throws:
  `IOException`

### parseStyleDeclaration

public CSSStyleDeclaration parseStyleDeclaration(String style) throws IOException
Description copied from interface: `CSSEngine`
Parse style declaration from String style.

Specified by:
  `parseStyleDeclaration` in interface `CSSEngine`
Throws:
  `IOException`

### parseStyleDeclaration

public CSSStyleDeclaration parseStyleDeclaration(Reader reader) throws IOException
Description copied from interface: `CSSEngine`
Parse style declaration from Reader reader.

Specified by:
  `parseStyleDeclaration` in interface `CSSEngine`
Throws:
  `IOException`

### parseStyleDeclaration

public CSSStyleDeclaration parseStyleDeclaration(InputStream stream) throws IOException
Description copied from interface: `CSSEngine`
Parse style declaration from InputStream stream.

Specified by:
  `parseStyleDeclaration` in interface `CSSEngine`
Throws:
  `IOException`

### parseStyleDeclaration

public CSSStyleDeclaration parseStyleDeclaration(org.w3c.css.sac.InputSource source) throws IOException
Description copied from interface: `CSSEngine`
Parse style declaration from InputSource source.

Specified by:
  `parseStyleDeclaration` in interface `CSSEngine`
Throws:
  `IOException`

### parseSelectors

public org.w3c.css.sac.SelectorList parseSelectors(String selector) throws IOException
Description copied from interface: `CSSEngine`
Parse Selectors from String value.

Specified by:
  `parseSelectors` in interface `CSSEngine`
Throws:
  `IOException`

### parseSelectors

public org.w3c.css.sac.SelectorList parseSelectors(Reader reader) throws IOException
Description copied from interface: `CSSEngine`
Parse Selectors from String value.

Specified by:
  `parseSelectors` in interface `CSSEngine`
Throws:
  `IOException`

### parseSelectors

public org.w3c.css.sac.SelectorList parseSelectors(InputStream stream) throws IOException
Description copied from interface: `CSSEngine`
Parse Selectors from InputStream.

Specified by:
  `parseSelectors` in interface `CSSEngine`
Throws:
  `IOException`

### parseSelectors

public org.w3c.css.sac.SelectorList parseSelectors(org.w3c.css.sac.InputSource source) throws IOException
Description copied from interface: `CSSEngine`
Parse Selectors from InputSource value.

Specified by:
  `parseSelectors` in interface `CSSEngine`
Throws:
  `IOException`

### parsePropertyValue

public CSSValue parsePropertyValue(Reader reader) throws IOException
Description copied from interface: `CSSEngine`
Parse CSSValue from Reader reader.

Specified by:
  `parsePropertyValue` in interface `CSSEngine`
Throws:
  `IOException`

### parsePropertyValue

public CSSValue parsePropertyValue(InputStream stream) throws IOException
Description copied from interface: `CSSEngine`
Parse CSSValue from InputStream stream.

Specified by:
  `parsePropertyValue` in interface `CSSEngine`
Throws:
  `IOException`

### parsePropertyValue

public CSSValue parsePropertyValue(String value) throws IOException
Description copied from interface: `CSSEngine`
Parse CSSValue from String value.

Specified by:
  `parsePropertyValue` in interface `CSSEngine`
Throws:
  `IOException`

### parsePropertyValue

public CSSValue parsePropertyValue(org.w3c.css.sac.InputSource source) throws IOException
Description copied from interface: `CSSEngine`
Parse CSSValue from InputSource source.

Specified by:
  `parsePropertyValue` in interface `CSSEngine`
Throws:
  `IOException`

### applyStyles

public void applyStyles(Object element, boolean applyStylesToChildNodes)
Description copied from interface: `CSSEngine`
Apply styles to the Object node (SWT Text,...). If `applyStylesToChildNodes` is true, apply styles to the child nodes (ex : if node is SWT Composite, styles are applied to the child controls too).

Specified by:
  `applyStyles` in interface `CSSEngine`

### applyStyles

public void applyStyles(Object element, boolean applyStylesToChildNodes, boolean computeDefaultStyle)
Description copied from interface: `CSSEngine`
Apply styles to the Object node (SWT Text,...). If `applyStylesToChildNodes` is true, apply styles to the child nodes (ex : if node is SWT Composite, styles are applied to the child controls too). If `computeDefaultStyle` is true, default style is computed before apply styles.

Specified by:
  `applyStyles` in interface `CSSEngine`

### isVisible

protected boolean isVisible(Element elt)
Allow the CSS engine to skip particular elements if they are not visible. Elements need to be restyled when they become visible.

Returns:
  true if the element is visible, false if not visible.

### getStaticPseudoInstances

protected String[] getStaticPseudoInstances(Element element)

### onStylesAppliedToChildNodes

protected void onStylesAppliedToChildNodes(Element element, NodeList nodes)
Callback method called when styles applied of `nodes` children of the `element`.

### applyStyleDeclaration

public void applyStyleDeclaration(Object element, CSSStyleDeclaration style, String pseudo)
Description copied from interface: `CSSEngine`
Apply style declaration to the object node.

Specified by:
  `applyStyleDeclaration` in interface `CSSEngine`

### parseAndApplyStyleDeclaration

public CSSStyleDeclaration parseAndApplyStyleDeclaration(Object node, Reader reader) throws IOException
Description copied from interface: `CSSEngine`
Parse and apply style declaration from Reader reader.

Specified by:
  `parseAndApplyStyleDeclaration` in interface `CSSEngine`
Throws:
  `IOException`

### parseAndApplyStyleDeclaration

public CSSStyleDeclaration parseAndApplyStyleDeclaration(Object node, InputStream stream) throws IOException
Description copied from interface: `CSSEngine`
Parse and apply style declaration from InputStream stream.

Specified by:
  `parseAndApplyStyleDeclaration` in interface `CSSEngine`
Throws:
  `IOException`

### parseAndApplyStyleDeclaration

public CSSStyleDeclaration parseAndApplyStyleDeclaration(Object node, org.w3c.css.sac.InputSource source) throws IOException
Description copied from interface: `CSSEngine`
Parse and apply style declaration from InputSource source.

Specified by:
  `parseAndApplyStyleDeclaration` in interface `CSSEngine`
Throws:
  `IOException`

### parseAndApplyStyleDeclaration

public CSSStyleDeclaration parseAndApplyStyleDeclaration(Object node, String style) throws IOException
Description copied from interface: `CSSEngine`
Parse and apply style declaration from String style.

Specified by:
  `parseAndApplyStyleDeclaration` in interface `CSSEngine`
Throws:
  `IOException`

### applyInlineStyle

public void applyInlineStyle(Object node, boolean applyStylesToChildNodes)
Description copied from interface: `CSSEngine`
Apply inline style of the object node. If `applyStylesToChildNodes` is true, apply style inline to the child nodes (ex : if node is SWT Composite, styles are applied to the child controls too).

Specified by:
  `applyInlineStyle` in interface `CSSEngine`

### getDefaultStyleDeclaration

public CSSStyleDeclaration getDefaultStyleDeclaration(Object element, String pseudoE)
Description copied from interface: `CSSEngine`
Get default `CSSStyleDeclaration` of the `node` for pseudo element `pseudoE` which can be null.

Specified by:
  `getDefaultStyleDeclaration` in interface `CSSEngine`

### getDefaultStyleDeclaration

public CSSStyleDeclaration getDefaultStyleDeclaration(Object widget, CSSStyleDeclaration newStyle, String pseudoE)

### applyDefaultStyleDeclaration

public void applyDefaultStyleDeclaration(Object element, boolean applyStylesToChildNodes)
Description copied from interface: `CSSEngine`
Apply initial style of the object node. If `applyStylesToChildNodes` is true, apply style inline to the child nodes (ex : if node is SWT Composite, styles are applied to the child controls too).

Specified by:
  `applyDefaultStyleDeclaration` in interface `CSSEngine`

### applyDefaultStyleDeclaration

public void applyDefaultStyleDeclaration(Object element, boolean applyStylesToChildNodes, CSSStyleDeclaration newStyle, String pseudoE)

### applyCSSProperty

public ICSSPropertyHandler applyCSSProperty(Object element, String property, CSSValue value, String pseudo) throws Exception
Delegates the handle method.

Specified by:
  `applyCSSProperty` in interface `CSSEngine`
Parameters:
  `element` - may be a widget or a node or some object
Throws:
  `Exception`

### retrieveCSSProperty

public String retrieveCSSProperty(Object element, String property, String pseudo)
Description copied from interface: `CSSEngine`
Retrieve String of `CSSValue` of the CSS `property` of the `node`.

Specified by:
  `retrieveCSSProperty` in interface `CSSEngine`

### getCSSCompositePropertiesNames

public String[] getCSSCompositePropertiesNames(String property)
Description copied from interface: `CSSEngine`
Return array of CSS property name of the CSS `property`.

Specified by:
  `getCSSCompositePropertiesNames` in interface `CSSEngine`

### getCSSPropertyHandlers

protected Collection<ICSSPropertyHandler> getCSSPropertyHandlers(String property) throws Exception

Throws:
  `Exception`

### getCSSProperties

public Collection<String> getCSSProperties(Object element)
Return the set of property names and handlers for the provided node.

Specified by:
  `getCSSProperties` in interface `CSSEngine`
Parameters:
  `element` - the DOM node or an element
Returns:
  the property names and handlers

### getElementProvider

public IElementProvider getElementProvider()
Description copied from interface: `CSSEngine`
Get `IElementProvider` registered used to retrieve w3c `Element` which wrap native widget.

Specified by:
  `getElementProvider` in interface `CSSEngine`

### setElementProvider

public void setElementProvider(IElementProvider elementProvider)
Description copied from interface: `CSSEngine`
Set `IElementProvider` registered used to retrieve w3c `Element` which wrap native widget.

Specified by:
  `setElementProvider` in interface `CSSEngine`

### getElement

public Element getElement(Object element)
Return the w3c Element linked to the Object element.

Specified by:
  `getElement` in interface `CSSEngine`

### hookNativeWidget

protected void hookNativeWidget(Object widget)
Called when an element context is created for a native widget and registered with this engine. Subclasses should override and install a listener on the widget that will call `handleWidgetDisposed(Object)` when the widget is disposed.

The default implementation of this method does nothing.

Parameters:
  `widget` - the native widget to hook

### handleWidgetDisposed

public void handleWidgetDisposed(Object widget)
Called when a widget is disposed. Removes the element context from the element contexts map and the widgets map. Overriding classes must call the super implementation.

Specified by:
  `handleWidgetDisposed` in interface `CSSEngine`
Parameters:
  `widget` - The widget that gets disposed.

### getCSSElementContext

public CSSElementContext getCSSElementContext(Object element)
Description copied from interface: `CSSEngine`
Get the `CSSElementContext` context of the object `node`.

Specified by:
  `getCSSElementContext` in interface `CSSEngine`

### getNativeWidget

public Object getNativeWidget(Object element)

### getElementsContext

protected Map<Object,CSSElementContext> getElementsContext()

### matches

public boolean matches(org.w3c.css.sac.Selector selector, Object element, String pseudoElt)
Description copied from interface: `CSSEngine`
Check if the `selector` matches the object `node`.

Specified by:
  `matches` in interface `CSSEngine`

### handleExceptions

public void handleExceptions(Exception e)
Handle exceptions thrown while parsing, applying styles. By default this method call CSS Error Handler if it is initialized.

Specified by:
  `handleExceptions` in interface `CSSEngine`

### getErrorHandler

public CSSErrorHandler getErrorHandler()
Description copied from interface: `CSSEngine`
Return `CSSErrorHandler` used to handles exception error.

Specified by:
  `getErrorHandler` in interface `CSSEngine`

### setErrorHandler

public void setErrorHandler(CSSErrorHandler errorHandler)
Set the CSS Error Handler to manage exception.

Specified by:
  `setErrorHandler` in interface `CSSEngine`

### getResourcesLocatorManager

public IResourcesLocatorManager getResourcesLocatorManager()
Description copied from interface: `CSSEngine`
Get the `IResourcesLocatorManager` to use manage resources.

Specified by:
  `getResourcesLocatorManager` in interface `CSSEngine`

### setResourcesLocatorManager

public void setResourcesLocatorManager(IResourcesLocatorManager resourcesLocatorManager)
Description copied from interface: `CSSEngine`
Set the `IResourcesLocatorManager` to use manage resources.

Specified by:
  `setResourcesLocatorManager` in interface `CSSEngine`

### getDocumentCSS

public DocumentCSS getDocumentCSS()
Description copied from interface: `CSSEngine`
Return the `DocumentCSS` used to store `CSSStyleSheet`.

Specified by:
  `getDocumentCSS` in interface `CSSEngine`

### getViewCSS

public ViewCSS getViewCSS()
Description copied from interface: `CSSEngine`
Return the `ViewCSS` used to compute `CSSStyleDeclaration`.

Specified by:
  `getViewCSS` in interface `CSSEngine`

### dispose

public void dispose()
Description copied from interface: `CSSEngine`
Call reset and dispose all resources

Specified by:
  `dispose` in interface `CSSEngine`

### reset

public void reset()
Description copied from interface: `CSSEngine`
Reset all style sheet registered into CSS Engine. This method must be called if you want parse and apply new StyleSheet and remove the old StyleSheet parsed.

Specified by:
  `reset` in interface `CSSEngine`

### getResourcesRegistry

public IResourcesRegistry getResourcesRegistry()
Description copied from interface: `CSSEngine`
Get the `IResourcesRegistry` registered used to cache/dispose resources.

Specified by:
  `getResourcesRegistry` in interface `CSSEngine`

### setResourcesRegistry

public void setResourcesRegistry(IResourcesRegistry resourcesRegistry)
Description copied from interface: `CSSEngine`
Register `IResourcesRegistry` used to cache/dispose resources.

Specified by:
  `setResourcesRegistry` in interface `CSSEngine`

### registerCSSPropertyHandlerProvider

public void registerCSSPropertyHandlerProvider(ICSSPropertyHandlerProvider handlerProvider)

### unregisterCSSPropertyHandlerProvider

public void unregisterCSSPropertyHandlerProvider(ICSSPropertyHandlerProvider handlerProvider)

### registerCSSValueConverter

public void registerCSSValueConverter(ICSSValueConverter converter)
Description copied from interface: `CSSEngine`
Register CSSValue converter `ICSSValueConverter`.

Specified by:
  `registerCSSValueConverter` in interface `CSSEngine`

### unregisterCSSValueConverter

public void unregisterCSSValueConverter(ICSSValueConverter converter)
Description copied from interface: `CSSEngine`
Unregister CSSValue converter `ICSSValueConverter`.

Specified by:
  `unregisterCSSValueConverter` in interface `CSSEngine`

### getCSSValueConverter

public ICSSValueConverter getCSSValueConverter(Object toType)
Description copied from interface: `CSSEngine`
Get CSSValue converter `ICSSValueConverter` which is enable to convert `toType` Object.

Specified by:
  `getCSSValueConverter` in interface `CSSEngine`

### convert

public Object convert(CSSValue value, Object toType, Object context) throws Exception
Description copied from interface: `CSSEngine`
Convert CSSValue into Object type of `toType`. (ex : convert CSSValue color:red into java.awt.Color). If `IResourcesRegistry` is registered into `CSSEngine` this method search before into cache of `IResourcesRegistry` if the Object was already converted.

Specified by:
  `convert` in interface `CSSEngine`
Parameters:
  `context` - can be null. For SWT context is org.eclipse.swt.widgets.Display.
Throws:
  `Exception`

### convert

public String convert(Object value, Object toType, Object context) throws Exception
Description copied from interface: `CSSEngine`
Convert Object type of `toType` into CSSValue String.

Specified by:
  `convert` in interface `CSSEngine`
Throws:
  `Exception`

### makeCSSParser

public abstract CSSParser makeCSSParser()
Return instance of CSS Parser.

### setResourceRegistryKeyFactory

protected void setResourceRegistryKeyFactory(ResourceRegistryKeyFactory keyFactory)